﻿
data:extend(
{
	{
		type     = "sprite",
		name     = "landmine-button-gui",
		filename = "__modmashsplinterboom__/boom.png",
		width    = 128,
		height   = 128
	}
})

local styles = data.raw["gui-style"]["default"]

styles["landmine-icon-button"] =
{
	type = "button_style",
	horizontal_align = "center",
	vertical_align = "center",
	icon_horizontal_align = "center",
	minimal_width = 36,
	height = 36,
	padding = 0,
	stretch_image_to_widget_size = true,
	default_graphical_set = base_icon_button_grahphical_set,
	hovered_graphical_set =
	{
		base = {position = {34, 17}, corner_size = 2, draw_type = "outer", opacity = 0.5},
		shadow = default_dirt,
		glow = default_glow(default_glow_color, 0.5)
	},
	clicked_graphical_set =
	{
		base   = {position = {51, 17}, corner_size = 2, draw_type = "outer", opacity = 0.5},
		shadow = default_dirt
	},
	selected_graphical_set =
	{
		base   = {position = {225, 17}, corner_size = 2, draw_type = "outer", opacity = 0.5},
		shadow = default_dirt
	},
	selected_hovered_graphical_set =
	{
		base   = {position = {369, 17}, corner_size = 2, draw_type = "outer", opacity = 0.5},
		shadow = default_dirt
	},
	strikethrough_color = {0.5, 0.5, 0.5},
	pie_progress_color = {1, 1, 1},
	left_click_sound =
	{
		{ filename = "__core__/sound/gui-click.ogg" }
	},
	draw_shadow_under_picture = true
}


-- data:extend(
-- {
	-- {
		-- type = "shortcut",
		-- name = "boom-toggle",
		-- localised_name = {"", {"Shortcuts.modmash-landmine-detonate-tooltip"}},
		-- order = "a[modmashsplinter]-[boom-toggle]",
		-- action = "lua",
		-- style = "red",
		-- icon =
		-- {
			-- filename = "__modmashsplinterboom__/graphics/toggle-x32.png",
			-- priority = "extra-high-no-scale",
			-- size = 32,
			-- scale = 1,
			-- flags = {"icon"}
		-- },
		-- small_icon =
		-- {
			-- filename = "__modmashsplinterboom__/graphics/toggle-x24.png",
			-- priority = "extra-high-no-scale",
			-- size = 24,
			-- scale = 1,
			-- flags = {"icon"}
		-- },
		-- disabled_icon =
		-- {
			-- filename = "__modmashsplinterboom__/graphics/toggle-x32-white.png",
			-- priority = "extra-high-no-scale",
			-- size = 32,
			-- scale = 1,
			-- flags = {"icon"}
		-- },
		-- disabled_small_icon =
		-- {
			-- filename = "__modmashsplinterboom__/graphics/toggle-x24-white.png",
			-- priority = "extra-high-no-scale",
			-- size = 24,
			-- scale = 1,
			-- flags = {"icon"}
		-- },
	-- }
-- })


data:extend(
{
	{
		type = "shortcut",
		name = "boom-toggle",
		localised_name = {"", {"Shortcuts.modmash-landmine-detonate-tooltip"}},
		order = "a[modmashsplinter]-[boom-toggle]",
		action = "lua",
		style = "red",
		
		icon = "__modmashsplinterboom__/graphics/toggle-x32.png",
		icon_size = 32,		
		icon_priority = "extra-high-no-scale",
		icon_scale = 1,
		icon_flags = {"icon"},
		
		small_icon = "__modmashsplinterboom__/graphics/toggle-x24.png",
		small_icon_priority = "extra-high-no-scale",
		small_icon_size = 24,
		small_icon_scale = 1,
		small_icon_flags = {"icon"},

		disabled_icon = "__modmashsplinterboom__/graphics/toggle-x32-white.png",
		disabled_icon_priority = "extra-high-no-scale",
		disabled_icon_size = 32,
		disabled_icon_scale = 1,
		disabled_icon_flags = {"icon"},
		
		disabled_small_icon = "__modmashsplinterboom__/graphics/toggle-x24-white.png",
		disabled_small_icon_priority = "extra-high-no-scale",
		disabled_small_icon_size = 24,
		disabled_small_icon_scale = 1,
		disabled_small_icon_flags = {"icon"}
	}
})





-- data:extend(
-- {
	-- {
		-- type = "shortcut",
		-- name = "boom-all-toggle",
		-- localised_name = {"", {"Shortcuts.modmash-landmine-detonate-all-tooltip"}},
		-- order = "a[modmashsplinter]-[boom-all-toggle]",
		-- action = "lua",
		-- style = "red",
		-- icon =
		-- {
			-- filename = "__modmashsplinterboom__/graphics/all-toggle-x32.png",
			-- priority = "extra-high-no-scale",
			-- size = 32,
			-- scale = 1,
			-- flags = {"icon"}
		-- },
		-- small_icon =
		-- {
			-- filename = "__modmashsplinterboom__/graphics/all-toggle-x24.png",
			-- priority = "extra-high-no-scale",
			-- size = 24,
			-- scale = 1,
			-- flags = {"icon"}
		-- },
		-- disabled_icon =
		-- {
			-- filename = "__modmashsplinterboom__/graphics/all-toggle-x32-white.png",
			-- priority = "extra-high-no-scale",
			-- size = 32,
			-- scale = 1,
			-- flags = {"icon"}
		-- },
		-- disabled_small_icon =
		-- {
			-- filename = "__modmashsplinterboom__/graphics/all-toggle-x24-white.png",
			-- priority = "extra-high-no-scale",
			-- size = 24,
			-- scale = 1,
			-- flags = {"icon"}
		-- },
	-- }
-- })

data:extend(
{
	{
		type = "shortcut",
		name = "boom-all-toggle",
		localised_name = {"", {"Shortcuts.modmash-landmine-detonate-all-tooltip"}},
		order = "a[modmashsplinter]-[boom-all-toggle]",
		action = "lua",
		style = "red",
		
		icon = "__modmashsplinterboom__/graphics/all-toggle-x32.png",
		icon_priority = "extra-high-no-scale",
		icon_size = 32,
		icon_scale = 1,
		icon_flags = {"icon"},
		
		small_icon = "__modmashsplinterboom__/graphics/all-toggle-x24.png",
		small_icon_priority = "extra-high-no-scale",
		small_icon_size = 24,
		small_icon_scale = 1,
		small_icon_flags = {"icon"},
		
		disabled_icon = "__modmashsplinterboom__/graphics/all-toggle-x32-white.png",
		disabled_priority = "extra-high-no-scale",
		disabled_size = 32,
		disabled_scale = 1,
		disabled_flags = {"icon"},
		
		disabled_small_icon = "__modmashsplinterboom__/graphics/all-toggle-x24-white.png",
		disabled_small_icon_priority = "extra-high-no-scale",
		disabled_small_icon_size = 24,
		disabled_small_icon_scale = 1,
		disabled_small_icon_flags = {"icon"}
	}
})

data:extend(
  {
	{
		type = "land-mine",
		name = "nuclear-land-mine",
		icon = "__modmashsplinterboom__/graphics/icons/land-mine-a.png",
		icon_size = 64,
		icon_mipmaps = 4,
		create_ghost_on_death = false,
		flags = { "placeable-player", "placeable-enemy", "player-creation", "placeable-off-grid", "not-on-map", "not-repairable" },
		minable = {mining_time = 0.5, result = "nuclear-land-mine"},
		mined_sound = { filename = "__core__/sound/deconstruct-small.ogg" },
		max_health = 15,
		corpse = "small-remnants",
		collision_box = {{-0.4,-0.4}, {0.4, 0.4}},
		selection_box = {{-0.5, -0.5}, {0.5, 0.5}},
		picture_safe =
		{
		  filename = "__modmashsplinterboom__/graphics/entity/land-mine/hr-land-mine-a.png",
		  priority = "medium",
		  width = 64,
		  height = 64,
		  scale = 0.5
		},
		picture_set =
		{
		  filename = "__modmashsplinterboom__/graphics/entity/land-mine/hr-land-mine-set-a.png",
		  priority = "medium",
		  width = 64,
		  height = 64,
		  scale = 0.5
		},
		picture_set_enemy =
		{
		  filename = "__base__/graphics/entity/land-mine/land-mine-set-enemy.png",
		  priority = "medium",
		  width = 32,
		  height = 32,
		},
		trigger_radius = 3,
		ammo_category = "landmine",
		action =
		{
		  type = "direct",
		  action_delivery =
		  {
			type = "instant",

			source_effects =
			{
			  {
				  repeat_count = 100,
				  type = "create-trivial-smoke",
				  smoke_name = "nuclear-smoke",
				  offset_deviation = {{-1, -1}, {1, 1}},
				  starting_frame = 3,
				  starting_frame_deviation = 5,
				  starting_frame_speed = 0,
				  starting_frame_speed_deviation = 5,
				  speed_from_center = 0.5
			  },
			  {
				type = "create-entity",
				entity_name = "explosion"
			  },
			  {
				type = "create-entity",
				entity_name = "huge-scorchmark",
				check_buildability = true,
			  },
			  {
				type = "camera-effect",
				effect = "screen-burn",
				duration = 60,
				ease_in_duration = 5,
				ease_out_duration = 60,
				delay = 0,
				strength = 6,
				full_strength_max_distance = 200,
				max_distance = 800
			  },
			  {
				type = "nested-result",
				affects_target = true,
				action =
				{
				  type = "area",
				  radius = 8,
				  force = "enemy",
				  action_delivery =
				  {
					type = "instant",
					target_effects =
					{
					  {
						type = "damage",
						damage = { amount = 400, type = "explosion"}
					  },
					}
				  }
				}
			  },
			  {
				type = "nested-result",
				affects_target = true,
				action =
				{
				  type = "area",
				  target_entities = false,
				  trigger_from_target = true,
				  repeat_count = 2000,
				  radius = 35,
				  action_delivery =
				  {
					type = "projectile",
					projectile = "atomic-bomb-wave",
					starting_speed = 0.5
				  }
				}
			  },
			  {
				explosion = "explosion",
				radius = 35,
				type = "destroy-cliffs"
			  },
			  {
				type = "nested-result",
				action =
				{
				  type = "area",
				  show_in_tooltip = false,
				  target_entities = false,
				  trigger_from_target = true,
				  repeat_count = 1000,
				  radius = 8,
				  action_delivery =
				  {
					type = "projectile",
					projectile = "atomic-bomb-wave-spawns-nuke-shockwave-explosion",
					starting_speed = 0.5 * 0.65,
					starting_speed_deviation = nuke_shockwave_starting_speed_deviation,
				  }
				}
			  },
			  {
				type = "nested-result",
				action =
				{
				  type = "area",
				  show_in_tooltip = false,
				  target_entities = false,
				  trigger_from_target = true,
				  repeat_count = 300,
				  radius = 26,
				  action_delivery =
				  {
					type = "projectile",
					projectile = "atomic-bomb-wave-spawns-nuclear-smoke",
					starting_speed = 0.5 * 0.65,
					starting_speed_deviation = nuke_shockwave_starting_speed_deviation,
				  }
				}
			  },
			  {
				type = "nested-result",
				action =
				{
				  type = "area",
				  show_in_tooltip = false,
				  target_entities = false,
				  trigger_from_target = true,
				  repeat_count = 10,
				  radius = 8,
				  action_delivery =
				  {
					type = "instant",
					target_effects =
					{
					  {
						type = "create-entity",
						entity_name = "nuclear-smouldering-smoke-source",
						tile_collision_mask = { layers={water_tile=true} }
					  }					  
					}
				  }
				}
			  },
			  {
				type = "nested-result",
				action =
				{
				  type = "area",
				  show_in_tooltip = false,
				  target_entities = false,
				  trigger_from_target = true,
				  repeat_count = 1,
				  radius = 1,
				  action_delivery =
				  {
					type = "instant",
					target_effects =
					{
					  {
						  apply_projection = true,
						  radius = 35,
						  tile_collision_mask = { layers={water_tile=true} },
						  tile_name = "nuclear-ground",
						  type = "set-tile"
					  }				  
					}
				  }
				}
			  }
			}
		  }
		}
	},
	{
      type = "item",
      name = "nuclear-land-mine",	  
      icon = "__modmashsplinterboom__/graphics/icons/land-mine-a.png",
	  icon_size = 64,
      subgroup = "gun",	  
      order = "f[land-mine][nuclear-land-mine]",	  
      place_result = "nuclear-land-mine",
      stack_size = 100
    },
	{
      type = "recipe",
      name = "nuclear-land-mine",
      enabled = false,	  
      icon = "__modmashsplinterboom__/graphics/icons/land-mine-a.png",
	  icon_size = 64,
      subgroup = "gun",	  
      order = "f[land-mine][nuclear-land-mine]",	
      energy_required = 5,
      ingredients = 
	  {
			{type = "item", name = "land-mine", amount = 1 },
			{type = "item", name = "explosives", amount = 4 },
			{type = "item", name = "uranium-235", amount = 100 }

      },
		results = {
			{type = "item", name = "nuclear-land-mine", amount = 1}
		}
    },
	{
      type = "technology",	
      name = "nuclear-land-mine",	
      icon = "__modmashsplinterboom__/graphics/icons/land-mine-at.png",
      icon_size = 256,	  
      effects = 
	  {
        {
          type = "unlock-recipe",		
          recipe = "nuclear-land-mine"
        }
      },
      prerequisites = { "bigger-land-mine", "military-4", "kovarex-enrichment-process" },
      unit =
	  {
        count = 100,
        ingredients = 
		{
			{"automation-science-pack", 1},
			{"logistic-science-pack", 1},
			{"chemical-science-pack", 1},
			{"military-science-pack", 1},
			{"utility-science-pack", 1}
        },
        time = 30
      },
	  upgrade = true,	  
      order = "e-e"	  
    },
})


data:extend(
  {
	{
		type = "land-mine",
		name = "bigger-land-mine",
		icon = "__modmashsplinterboom__/graphics/icons/land-mine-b.png",
		icon_size = 64,
		icon_mipmaps = 4,
		create_ghost_on_death = false,
		flags = { "placeable-player",  "placeable-enemy", "player-creation", "placeable-off-grid", "not-on-map", "not-repairable" },
		minable = {mining_time = 0.5, result = "bigger-land-mine"},
		mined_sound = { filename = "__core__/sound/deconstruct-small.ogg" },
		max_health = 15,
		corpse = "small-remnants",
		collision_box = {{-0.4,-0.4}, {0.4, 0.4}},
		selection_box = {{-0.5, -0.5}, {0.5, 0.5}},
		picture_safe =
		{
		  filename = "__modmashsplinterboom__/graphics/entity/land-mine/hr-land-mine-b.png",
		  priority = "medium",
		  width = 64,
		  height = 64,
		  scale = 0.5
		},
		picture_set =
		{
		  filename = "__modmashsplinterboom__/graphics/entity/land-mine/hr-land-mine-set-b.png",
		  priority = "medium",
		  width = 64,
		  height = 64,
		  scale = 0.5
		},
		picture_set_enemy =
		{
		  filename = "__base__/graphics/entity/land-mine/land-mine-set-enemy.png",
		  priority = "medium",
		  width = 32,
		  height = 32
		},
		trigger_radius = 3,
		ammo_category = "landmine",
		action =
		{
		  type = "direct",
		  action_delivery =
		  {
			type = "instant",
			source_effects =
			{
			  {
				type = "nested-result",
				affects_target = true,
				action =
				{
				  type = "area",
				  radius = 5,
				  force = "enemy",
				  action_delivery =
				  {
					type = "instant",
					target_effects =
					{
					  {
						type = "damage",
						damage = { amount = 650, type = "explosion"}
					  },
					  {
						type = "create-sticker",
						sticker = "stun-sticker"
					  }
					}
				  }
				}
			  },
			  {
				explosion = "explosion",
				radius = 5,
				type = "destroy-cliffs"
			  },
			  {
				type = "create-entity",
				entity_name = "big-explosion"
			  },
			  {
				type = "damage",
				damage = { amount = 1500, type = "explosion"}
			  }
			}
		  }
		}
	},
	{
      type = "item",
      name = "bigger-land-mine",	  
      icon = "__modmashsplinterboom__/graphics/icons/land-mine-b.png",
	  icon_size = 64,
      subgroup = "gun",
      order = "f[land-mine][bigger-land-mine]",	  
      place_result = "bigger-land-mine",
      stack_size = 100
    },
	{
      type = "recipe",
      name = "bigger-land-mine",	  
      enabled = false,
      icon = "__modmashsplinterboom__/graphics/icons/land-mine-b.png",
	  icon_size = 64,
      subgroup = "gun",
      order = "f[land-mine][bigger-land-mine]",
      energy_required = 5,
      ingredients = 
	  {
			{type = "item", name = "land-mine", amount = 1 }, 
			{type = "item", name = "explosives", amount = 4 }
      },
		results = {
			{type = "item", name = "bigger-land-mine", amount = 1}
		}
    },
	{
      type = "technology",	
      name = "bigger-land-mine",
      icon = "__modmashsplinterboom__/graphics/icons/land-mine-bt.png",
      icon_size = 256,	
      effects = 
	  {
        {
          recipe = "bigger-land-mine",
          type = "unlock-recipe"
        }
      },	  
      prerequisites = { "land-mine", "military-3" },	 
      unit = {
        count = 100,
        ingredients = 
		{
			{"automation-science-pack", 1},
			{"logistic-science-pack", 1},
			{"chemical-science-pack", 1},
			{"military-science-pack", 1}
        },
        time = 30
      },  
	  upgrade = true,
      order = "e-e"
    }
})
